Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Private Sub LoadGrid()
        Dim dt As New DataTable("Test")
        dt.Columns.Add("Unit", System.Type.GetType("System.String"))
        dt.Columns.Add("Value", System.Type.GetType("System.String"))

        Dim dr As DataRow
        dr = dt.NewRow
        dr.Item("Unit") = "LF"
        dr.Item("Value") = "10"
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr.Item("Unit") = "SF"
        dr.Item("Value") = "20"
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr.Item("Unit") = "R1"
        dr.Item("Value") = ""
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr.Item("Unit") = "R2"
        dr.Item("Value") = ""
        dt.Rows.Add(dr)

        UltraGrid1.DataSource = dt
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        LoadGrid()

        Dim reference As New Infragistics.Win.UltraWinCalcManager.NamedReference
        reference.Key = "Column 1"


        Dim calcManager As Infragistics.Win.UltraWinCalcManager.UltraCalcManager
        calcManager = New Infragistics.Win.UltraWinCalcManager.UltraCalcManager(Me.Container)
        UltraGrid1.CalcManager = calcManager
        calcManager.NamedReferences.Add(reference)

    End Sub

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        e.Layout.Bands(0).Summaries.Add("Value", Infragistics.Win.UltraWinGrid.SummaryType.Formula, Me.UltraGrid1.DisplayLayout.Bands(0).Columns("Value"), Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn)

        e.Layout.Bands(0).Summaries("Value").Formula = "[//ultragrid1/Test(Unit=LF)/Value]"
        e.Layout.Bands(0).Summaries("Value").Formula = "[//ultragrid1/Test(Unit=SF)/Value]"
        e.Layout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.UltraCalcManager1.NamedReferences.Clear()

        ' Add two named references named N1 and N2. N2 multiplies the value of
        ' N1 by 2.
        Me.UltraCalcManager1.NamedReferences.Add("N1", "5")
        Me.UltraCalcManager1.NamedReferences.Add("N2", "2 * [N1]")
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        MessageBox.Show(Me.UltraCalcManager1.NamedReferences("N2").FormulaResult.ToString)

    End Sub

End Class
