Public Class Form2
    Private Sub LoadGrid()
        Dim dt As New DataTable("Test")
        dt.Columns.Add("LEN", System.Type.GetType("System.String"))
        dt.Columns.Add("WID", System.Type.GetType("System.String"))
        dt.Columns.Add("HGT", System.Type.GetType("System.String"))
        dt.Columns.Add("F1", System.Type.GetType("System.String"))
        dt.Columns.Add("F2", System.Type.GetType("System.String"))

        Dim dr As DataRow
        dr = dt.NewRow
        dr.Item("LEN") = "0"
        dr.Item("WID") = "0"
        dr.Item("HGT") = "0"
        dr.Item("F1") = ""
        dr.Item("F2") = ""
        dt.Rows.Add(dr)

        UltraGrid2.DataSource = dt
    End Sub

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        LoaMainGrid()

        LoadGrid()
    End Sub

    Private Sub UltraGrid2_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid2.InitializeLayout
        Dim calcManager As Infragistics.Win.UltraWinCalcManager.UltraCalcManager
        calcManager = New Infragistics.Win.UltraWinCalcManager.UltraCalcManager(Me.Container)
        e.Layout.Grid.CalcManager = calcManager

        e.Layout.Bands(0).Columns("F1").Formula = "([LEN]+[WID])*2"
        e.Layout.Bands(0).Columns("F2").Formula = "(2*[LEN]*[HGT])+(2*[WID]*[HGT]) + ([LEN]*[WID])"

        'e.Layout.Bands(0).Columns("LEN").Formula = "[//UltraGrid1/Table(Unit=LEN)/Value]"

    End Sub

    Private Sub LoaMainGrid()
        Dim dt As New DataTable("Table")
        dt.Columns.Add("Unit", System.Type.GetType("System.String"))
        dt.Columns.Add("Value", System.Type.GetType("System.String"))

        Dim dr As DataRow
        dr = dt.NewRow
        dr.Item("Unit") = "LEN"
        dr.Item("Value") = "10"
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr.Item("Unit") = "WID"
        dr.Item("Value") = "20"
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr.Item("Unit") = "HGT"
        dr.Item("Value") = "20"
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr.Item("Unit") = "F1"
        dr.Item("Value") = ""
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr.Item("Unit") = "F2"
        dr.Item("Value") = ""
        dt.Rows.Add(dr)

        UltraGrid1.DataSource = dt
    End Sub

    Private Sub UltraGrid1_AfterCellUpdate(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.CellEventArgs) Handles UltraGrid1.AfterCellUpdate
        Dim colName As String
        For i As Integer = 0 To UltraGrid2.DisplayLayout.Bands(0).Columns.Count - 1
            If UltraGrid1.ActiveRow.Cells("Unit").Value.ToString.ToUpper = UltraGrid2.DisplayLayout.Bands(0).Columns(i).ToString.ToUpper Then
                colName = UltraGrid1.ActiveRow.Cells("Unit").Value.ToString.ToUpper
                UltraGrid2.Rows(0).Cells(colName).Value = UltraGrid1.ActiveRow.Cells("Value").Value
            End If
        Next
    End Sub
End Class